SDL_AddGamepadMappingsFromIO(3)

NAME
SDL_AddGamepadMappingsFromIO - Load a set of gamepad mappings from an SDL_IOStream.

SYNOPSIS
#include <SDL3/SDL_gamepad.h>

int SDL_AddGamepadMappingsFromIO(SDL_IOStream *src, bool closeio);

DESCRIPTION
You can call this function several times, if needed, to load different database files.

If a new mapping is loaded for an already known gamepad GUID, the later version will overwrite the one currently loaded.

Any new mappings for already plugged in controllers will generate SDL_EVENT_GAMEPAD_ADDED events.

Mappings not belonging to the current platform or with no platform field specified will be ignored (i.e. mappings for Linux will be ignored in Windows, etc).

This function will load the text database entirely in memory before processing it, so take this into consideration if you are in a memory constrained environment.

FUNCTION PARAMETERS

src the data stream for the mappings to be added.

closeio
    if true, calls SDL_CloseIO() on src before returning, even in the case of an error.

RETURN VALUE
Returns the number of mappings added or -1 on failure; call SDL_GetError() for more information.

THREAD SAFETY
It is safe to call this function from any thread.

AVAILABILITY
This function is available since SDL 3.2.0.

SEE ALSO
SDL_AddGamepadMapping(3), SDL_AddGamepadMappingsFromFile(3), SDL_GetGamepadMapping(3), SDL_GetGamepadMappingForGUID(3), SDL_HINT_GAMECONTROLLERCONFIG(3), SDL_HINT_GAMECONTROLLERCONFIG_FILE(3), SDL_EVENT_GAMEPAD_ADDED(3)